import java.util.*;

public class Library {
	LinkedList<Book> library;
	
public Library() { library = new LinkedList<Book>(); }

public boolean add(Book book) {
	if (library.contains(book)) return false;
	else {
	    library.add(book);
	    return true;
	}    
}



public boolean contains(String isbn) {
   return library.contains(new Book(isbn));
}

public boolean remove(String isbn) {
	   return library.remove(new Book(isbn));
}


public void sort_by_isbn() {
	Collections.sort(library);
}

public void sort_by_title() {
	Collections.sort(library, new ByTytle());
}


public int count (String author) {
	int c = 0;
	for (Book book: library) if (book.getAuthors().contains(author)) c++;
	return c;
}


@Override 
public String toString(){
	return library.toString();
}
 

public static void main(String[] args) {
	Library lib = new Library(); 
	lib.add(new Book("Dante Alighieri", "La Divina Commedia", "999999999999"));
	ArrayList<String> authors = new ArrayList<String>();
	authors.add("Pippo");
	authors.add("Pluto");
	lib.add(new Book(authors, "Titolo 3", "123345566666"));
	lib.add(new Book("Pippo", "Titolo 2", "2222222222222"));
	System.out.println("Libreria:\n" + lib);
	lib.sort_by_isbn();
	System.out.println("Ordinata per isbn:\n" + lib);
	lib.sort_by_title();
	System.out.println("Ordinata per titolo:\n" + lib);
	System.out.println("Pippo ha scritto " + lib.count("Pippo") + " libri");
} //main

}//end-class


class ByTytle implements Comparator<Book>{
	public int compare(Book b1, Book b2) {
		return b1.getTitle().compareTo(b2.getTitle());
	}			
} //end-class
