import java.util.*;

public class Rubrica {
	LinkedList<Contatto> rubrica;
	
public Rubrica() { rubrica = new LinkedList<Contatto>(); }

//EX a)
public boolean aggiungiContatto(String nome, String cognome, String telefono) {
	Contatto contatto = new Contatto(nome, cognome, telefono);
	for (Contatto c: rubrica)
		if (c.equals(contatto)) return c.addNumero(telefono);
	return rubrica.add(contatto);    
}

//EX b)
boolean rimuoviContatto(String nome, String cognome) {
	return rubrica.remove(new Contatto(nome, cognome, new ArrayList<String>() ));
}

//EX c)
List<String> cerca(String  nome,  String  cognome){
	Contatto contatto = new Contatto(nome, cognome, new ArrayList<String>());
	for (Contatto c: rubrica)
		if (c.equals(contatto)) return c.getNumeri() ;
	return null;
}

//EX d)
public void Sort_by_name() {
	Collections.sort(rubrica);
}

//EX e)
public void Sort_by_surname() {
	Collections.sort(rubrica, new ByCognome());
}
class ByCognome implements Comparator<Contatto>{
	public int compare(Contatto c1, Contatto c2) {
		int compareCognome = c1.getCognome().compareToIgnoreCase(c2.getCognome());
		if (compareCognome==0) return c1.getNome().compareToIgnoreCase(c2.getNome());
		else return compareCognome;
	}			
} //end-class-ByCognome

//EX f)
public void Print() {
	for (Contatto c: rubrica) System.out.println(c);
}


@Override 
public String toString(){
	String s = new String();
	for (Contatto c: rubrica) s = s + "\n" + c.toString();
	return s;
}
 

public static void main(String[] args) {
	Rubrica rubrica = new Rubrica(); 
	rubrica.aggiungiContatto("Anna", "Rossi", "346333333");
	rubrica.aggiungiContatto("Anna", "Rossi", "346444444");
	rubrica.aggiungiContatto("Anna", "ROSSI", "346555555");
	rubrica.aggiungiContatto("Anna", "Rossi", "346555555"); //inserimento fallisce
	rubrica.aggiungiContatto("Paolo", "Bianchi", "346111111");
	rubrica.aggiungiContatto("PAOLO", "Bianchi", "346222222");
	rubrica.aggiungiContatto("Carlo", "Neri", "345000000");
	rubrica.aggiungiContatto("Carlo", "NERI", "347999999");
	rubrica.Print();
	
	System.out.print("\nRubrica ordinata per nome: ");
	rubrica.Sort_by_name();
	System.out.println(rubrica); //NB

	System.out.println("\nElenco numeri di Paolo Bianchi: " + 
				rubrica.cerca("paolO", "BianCHI"));
	rubrica.rimuoviContatto("Paolo","BiANchi");
	System.out.println("\nRubrica ordinata per cognome (senza Paolo Bianchi): ");
	rubrica.Sort_by_surname();
	rubrica.Print();


} //main

}//end-class



